from ezdxf.tools.text import MTextEditor

# Hood Schedule Table START

def draw_hood_schedule_table(msp, x_offset=0, y_offset=0, number_of_hoods=2, table_data={}):
    
    hood_information = table_data["HOOD_INFORMATION"]
    cabinet_information = table_data["CABINET_INFORMATION"]
    hood_scheule_information = table_data["HOOD_SCHEDULE_INFO"]
    
    hood_table_head_row_points = [
        (x_offset, y_offset),
        (x_offset + 450, y_offset),
        (x_offset + 450, y_offset - 26),
        (x_offset, y_offset - 26),
        (x_offset, y_offset - 19),
        (x_offset + 450, y_offset - 19),
        (x_offset + 450, y_offset - 10),
        (x_offset, y_offset - 10),
        (x_offset, y_offset - 21),
    ]
    
    hood_table_heading = str(MTextEditor("HOOD SCHEDULE").font(name="Arial-Bold", bold=True))

    msp.add_mtext(
        hood_table_heading, 
        dxfattribs={
            'insert': (x_offset + 220, y_offset - 3), 
            'layer': 'TABLE',
            'char_height': 5,     
        }
    )
    
    msp.add_lwpolyline(hood_table_head_row_points, close=True, dxfattribs={'layer': 'TABLE'})
    
    hood_table_head_column_points = [
        (x_offset, y_offset - 10),
        # first column
        (x_offset + 127, y_offset - 10),
        (x_offset + 127, y_offset - 19),
        # second column
        (x_offset + 127 + 67, y_offset - 19),
        (x_offset + 127 + 67, y_offset - 10),
        # third column
        (x_offset + 127 + 67 + 19, y_offset - 10),
        (x_offset + 127 + 67 + 19, y_offset - 19),
        # fourth column
        (x_offset + 127 + 67 + 19 + 22, y_offset - 19),
        (x_offset + 127 + 67 + 19 + 22, y_offset - 10),
        # fifth column
        (x_offset + 127 + 67 + 19 + 22 + 46, y_offset - 10),
        (x_offset + 127 + 67 + 19 + 22 + 46, y_offset - 19),
        # sixth column
        (x_offset + 127 + 67 + 19 + 22 + 46 + 19, y_offset - 19),
        (x_offset + 127 + 67 + 19 + 22 + 46 + 19, y_offset - 10),
        # seventh column
        (x_offset + 127 + 67 + 19 + 22 + 46 + 19 + 24, y_offset - 10),
        (x_offset + 127 + 67 + 19 + 22 + 46 + 19 + 24, y_offset - 19),
        # eighth column
        (x_offset + 127 + 67 + 19 + 22 + 46 + 19 + 24 + 37, y_offset - 19),
        (x_offset + 127 + 67 + 19 + 22 + 46 + 19 + 24 + 37, y_offset - 10),
        # ninth column
        (x_offset + 127 + 67 + 19 + 22 + 46 + 19 + 24 + 37 + 44, y_offset - 10),
        (x_offset + 127 + 67 + 19 + 22 + 46 + 19 + 24 + 37 + 44, y_offset - 19),
        # tenth column
        (x_offset + 127 + 67 + 19 + 22 + 46 + 19 + 24 + 37 + 44 + 45, y_offset - 19),
        (x_offset + 127 + 67 + 19 + 22 + 46 + 19 + 24 + 37 + 44 + 45, y_offset - 10),
        
        (x_offset + 127 + 67 + 19 + 22 + 46 + 19 + 24 + 37 + 44 + 45, y_offset - 19),
        (x_offset, y_offset - 19),
    ]
    
    first_column_x = x_offset + (120 / 2)
    first_column_y = (y_offset - 13)
    
    msp.add_mtext(
        "HOOD",
        dxfattribs={
            'insert': (first_column_x, first_column_y),
            'layer': 'TABLE',
            'char_height': 3  
        }
    )
    
    second_column_x = x_offset + 120 + (45 / 2)
    second_column_y = (y_offset - 13)
    
    msp.add_mtext(
        "EXHAUST COLLAR",
        dxfattribs={
            'insert': (second_column_x, second_column_y),
            'layer': 'TABLE',
            'char_height': 3  
        }
    )
    
    third_column_x = x_offset + 127 + 67 + (19 / 2)
    third_column_y = (y_offset - 14)
    
    msp.add_mtext(
        "COLLAR \nAREA",
        dxfattribs={
            'insert': (third_column_x, third_column_y),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    fourth_column_x = x_offset + 127 + 67 + 19 + (22 / 2)
    fourth_column_y = (y_offset - 14)
    
    msp.add_mtext(
        "GEASE DUCT \nVELOCITY",
        dxfattribs={
            'insert': (fourth_column_x, fourth_column_y),
            'layer': 'TABLE',
            'char_height': 1.75,
            'attachment_point': 5  
        }
    )
    
    fifth_column_x = x_offset + 127 + 67 + 19 + 22 + (38 / 2)
    fifth_column_y = (y_offset - 13)
    
    msp.add_mtext(
        "FILTERS",
        dxfattribs={
            'insert': (fifth_column_x, fifth_column_y),
            'layer': 'TABLE',
            'char_height': 1.75  
        }
    )
    
    sixth_column_x = x_offset + 127 + 67 + 19 + 22 + 46 + (10 / 2)
    sixth_column_y = (y_offset - 13)
    
    msp.add_mtext(
        "FILTER \n AREA",
        dxfattribs={
            'insert': (sixth_column_x, sixth_column_y),
            'layer': 'TABLE',
            'char_height': 1.75  
        }
    )
    
    seventh_column_x = x_offset + 127 + 67 + 19 + 22 + 46 + 19 + (2 / 2)
    seventh_column_y = (y_offset - 13)
    
    msp.add_mtext(
        "VELOCITY THRU \n EX FILTERS",
        dxfattribs={
            'insert': (seventh_column_x, seventh_column_y),
            'layer': 'TABLE',
            'char_height': 1.75  
        }
    )
    
    eighth_column_x = x_offset + 127 + 67 + 19 + 22 + 46 + 19 + 22 + (32 / 2)
    eighth_column_y = (y_offset - 13)
    
    msp.add_mtext(
        "LIGHTS",
        dxfattribs={
            'insert': (eighth_column_x, eighth_column_y),
            'layer': 'TABLE',
            'char_height': 1.75  
        }
    )
    
    ninth_column_x = x_offset + 127 + 67 + 19 + 22 + 46 + 19 + 22 + 37 + (28 / 2)
    ninth_column_y = (y_offset - 13)
    
    msp.add_mtext(
        "UTILITY CABINET",
        dxfattribs={
            'insert': (ninth_column_x, ninth_column_y),
            'layer': 'TABLE',
            'char_height': 1.75  
        }
    )
    
    tenth_column_x = x_offset + 127 + 67 + 19 + 22 + 46 + 19 + 22 + 37 + 44 + (38 / 2)
    tenth_column_y = (y_offset - 13)
    
    msp.add_mtext(
        "SWITCHES",
        dxfattribs={
            'insert': (tenth_column_x, tenth_column_y),
            'layer': 'TABLE',
            'char_height': 1.75  
        }
    )
    
    msp.add_lwpolyline(hood_table_head_row_points, close=True, dxfattribs={'layer': 'TABLE'})
    
    msp.add_lwpolyline(hood_table_head_column_points, close=True, dxfattribs={'layer': 'TABLE'})
    
    hood_table_secondary_head_column_points1 = [
        (x_offset, y_offset - 26),
        
        (x_offset + 10, y_offset - 26),
        (x_offset + 10, y_offset - 19),
        
        (x_offset + 10 + 20, y_offset - 19),
        (x_offset + 10 + 20, y_offset - 26),
        
        (x_offset + 10 + 20 + 30, y_offset - 26),
        (x_offset + 10 + 20 + 30, y_offset - 19),
        
        (x_offset + 10 + 20 + 30 + 15, y_offset - 19),
        (x_offset + 10 + 20 + 30 + 15, y_offset - 26),
        
        (x_offset + 10 + 20 + 30 + 15 + 16, y_offset - 26),
        (x_offset + 10 + 20 + 30 + 15 + 16, y_offset - 19),
        
        (x_offset + 10 + 20 + 30 + 15 + 16 + 21, y_offset - 19),
        (x_offset + 10 + 20 + 30 + 15 + 16 + 21, y_offset - 26),
        
        (x_offset + 10 + 20 + 30 + 15 + 16 + 21 + 15, y_offset - 26),
        (x_offset + 10 + 20 + 30 + 15 + 16 + 21 + 15, y_offset - 19),
        
        (x_offset, y_offset - 19),
    ]
    
    msp.add_mtext(
        "#",
        dxfattribs={
            'insert': (x_offset + 5, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "MFG",
        dxfattribs={
            'insert': (x_offset + 20, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "MODEL",
        dxfattribs={
            'insert': (x_offset + 45, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "LENGTH",
        dxfattribs={
            'insert': (x_offset + 68, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "TYPE",
        dxfattribs={
            'insert': (x_offset + 83, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "MATERIAL",
        dxfattribs={
            'insert': (x_offset + 102, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "WGT (LBS)",
        dxfattribs={
            'insert': (x_offset + 120, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.65 ,
            'attachment_point': 5
        }
    )
    
    for i in range(number_of_hoods):
        hood_table_secondary_head_column_points1_data = [
            (x_offset, y_offset - 26 - (i + 1) * 7),
        
            (x_offset + 10, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 10 + 20, y_offset - 19 - (i + 1) * 7),
            (x_offset + 10 + 20, y_offset - 26 - (i + 1) * 7),
            
            (x_offset + 10 + 20 + 30, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 30, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 10 + 20 + 30 + 15, y_offset - 19 - (i + 1) * 7),
            (x_offset + 10 + 20 + 30 + 15, y_offset - 26 - (i + 1) * 7),
            
            (x_offset + 10 + 20 + 30 + 15 + 16, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 30 + 15 + 16, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 10 + 20 + 30 + 15 + 16 + 21, y_offset - 19 - (i + 1) * 7),
            (x_offset + 10 + 20 + 30 + 15 + 16 + 21, y_offset - 26 - (i + 1) * 7),
            
            (x_offset + 10 + 20 + 30 + 15 + 16 + 21 + 15, y_offset - 26 - (i + 1) * 7),
            (x_offset + 10 + 20 + 30 + 15 + 16 + 21 + 15, y_offset - 19 - (i + 1) * 7),
            
            (x_offset, y_offset - 19 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            hood_scheule_information[i]["HOOD_NO"],
            dxfattribs={
                'insert': (x_offset + 5, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_scheule_information[i]["MFG"],
            dxfattribs={
                'insert': (x_offset + 20, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_scheule_information[i]["MODEL"],
            dxfattribs={
                'insert': (x_offset + 45, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_information[i]["HOODLENGTH"],
            dxfattribs={
                'insert': (x_offset + 68, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_scheule_information[i]["HOOD_TYPE"],
            dxfattribs={
                'insert': (x_offset + 83, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_scheule_information[i]["MATERIAL"],
            dxfattribs={
                'insert': (x_offset + 102, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_scheule_information[i]["HOOD_WGT"],
            dxfattribs={
                'insert': (x_offset + 120, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.65 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset, y_offset - 26 - (i + 1) * 7),
                (x_offset + 10 + 20 + 10 + 15 + 20, y_offset - 26 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=True, dxfattribs={'layer': 'TABLE'})
    
        msp.add_lwpolyline(hood_table_secondary_head_column_points1_data, close=True, dxfattribs={'layer': 'TABLE'})
        
    msp.add_lwpolyline(hood_table_secondary_head_column_points1, close=True, dxfattribs={'layer': 'TABLE'})
    
    hood_table_secondary_head_column_points2 = [
        (x_offset + 127, y_offset - 26),
        
        (x_offset + 127 + 10, y_offset - 26),
        (x_offset + 127 + 10, y_offset - 19),
        
        (x_offset + 127 + 10 + 25, y_offset - 19),
        (x_offset + 127 + 10 + 25, y_offset - 26),
        
        (x_offset + 127 + 10 + 25 + 16, y_offset - 26),
        (x_offset + 127 + 10 + 25 + 16, y_offset - 19),
        
        (x_offset + 127 + 10 + 25 + 16 + 16, y_offset - 19),
        (x_offset + 127 + 10 + 25 + 16 + 16, y_offset - 26),
    ]
    
    msp.add_mtext(
        "QTY",
        dxfattribs={
            'insert': (x_offset + 127 + 5, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "SIZE",
        dxfattribs={
            'insert': (x_offset + 127 + 5 + 17, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "S.P.",
        dxfattribs={
            'insert': (x_offset + 127 + 5 + 23 + 15, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "CFM",
        dxfattribs={
            'insert': (x_offset + 127 + 5 + 25 + 15 + 15, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    for i in range(number_of_hoods):
        hood_table_secondary_head_column_points2_data = [
            (x_offset + 127, y_offset - 26 - (i + 1) * 7),
            
            (x_offset + 127 + 10, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 127 + 10 + 25, y_offset - 19 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25, y_offset - 26 - (i + 1) * 7),
            
            (x_offset + 127 + 10 + 25 + 16, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 127 + 10 + 25 + 16 + 16, y_offset - 19 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16, y_offset - 26 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            hood_scheule_information[i]["EXH_COLLAR_QTY"],
            dxfattribs={
                'insert': (x_offset + 127 + 5, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            f'{hood_information[i]["EXH_COLLAR_SIZE"]}',
            dxfattribs={
                'insert': (x_offset + 127 + 5 + 17, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_scheule_information[i]["EXH_COLLAR_SP"],
            dxfattribs={
                'insert': (x_offset + 127 + 5 + 23 + 15, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_scheule_information[i]["EXH_COLLAR_CFM"],
            dxfattribs={
                'insert': (x_offset + 127 + 5 + 25 + 15 + 15, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 10 + 20 + 10 + 15 + 20, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16, y_offset - 26 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=True, dxfattribs={'layer': 'TABLE'})
        
        msp.add_lwpolyline(hood_table_secondary_head_column_points2_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_lwpolyline(hood_table_secondary_head_column_points2, close=False, dxfattribs={'layer': 'TABLE'})
    
    hood_table_secondary_head_column_points3 = [
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19, y_offset - 26),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19, y_offset - 19),
    ]
    
    for i in range(number_of_hoods):
        hood_table_secondary_head_column_points3_data = [
            (x_offset + 127 + 10 + 25 + 16 + 16, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19, y_offset - 19 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            hood_scheule_information[i]["EXH_COLLAR_AREA"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 9, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 127 + 10 + 25 + 16 + 16, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19, y_offset - 19 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=False, dxfattribs={'layer': 'TABLE'})
        
        msp.add_lwpolyline(hood_table_secondary_head_column_points3_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_mtext(
        "(SQFT)",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 9, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_lwpolyline(hood_table_secondary_head_column_points3, close=True, dxfattribs={'layer': 'TABLE'})
    
    hood_table_secondary_head_column_points4 = [
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6, y_offset - 26),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6, y_offset - 19),
    ]
    
    for i in range(number_of_hoods):
        hood_table_secondary_head_column_points4_data = [
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6, y_offset - 19 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            hood_scheule_information[i]["GREASE_COLLAR_VELOCITY"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 25 + 4, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6, y_offset - 19 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=False, dxfattribs={'layer': 'TABLE'})
        msp.add_lwpolyline(hood_table_secondary_head_column_points4_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_mtext(
        "(FPM)",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 25 + 4, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_lwpolyline(hood_table_secondary_head_column_points4, close=True, dxfattribs={'layer': 'TABLE'})
    
    hood_table_secondary_head_column_points5 = [
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6, y_offset - 26),
        
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15, y_offset - 26),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15, y_offset - 19),
        
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11, y_offset - 19),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11, y_offset - 26),
        
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20, y_offset - 26),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20, y_offset - 19),
    ]
    
    for i in range(number_of_hoods):
        hood_table_secondary_head_column_points5_data = [
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6, y_offset - 26 - (i + 1) * 7),
            
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11, y_offset - 19 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11, y_offset - 26 - (i + 1) * 7),
            
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20, y_offset - 19 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            hood_scheule_information[i]["FILTER_TYPE"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 8, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_scheule_information[i]["FILTER_QTY1"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 8 + 12, y_offset - 21 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.4 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_scheule_information[i]["FILTER_QTY2"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 8 + 12, y_offset - 24.5 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.4 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_scheule_information[i]["FILTER_SIZE1"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 8 + 12 + 16, y_offset - 21 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.4 ,
                'attachment_point': 5
            }
        )
        msp.add_mtext(
            hood_scheule_information[i]["FILTER_SIZE2"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 8 + 12 + 16, y_offset - 24.5 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.4 ,
                'attachment_point': 5
            }
        )
        
        splitter_points = [
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15, y_offset - 23 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20, y_offset - 23 - (i + 1) * 7),
        ]
        
        msp.add_lwpolyline(splitter_points, close=True, dxfattribs={'layer': 'TABLE'})
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20, y_offset - 19 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=False, dxfattribs={'layer': 'TABLE'})
        msp.add_lwpolyline(hood_table_secondary_head_column_points5_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_mtext(
        "TYPE",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 8, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "QTY",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 8 + 12, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "SIZE",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 8 + 12 + 16, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_lwpolyline(hood_table_secondary_head_column_points5, close=False, dxfattribs={'layer': 'TABLE'})
    
    hood_table_secondary_head_column_points6 = [
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20, y_offset - 26),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19, y_offset - 26),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19, y_offset - 19),
    ]
    
    for i in range(number_of_hoods):
        hood_table_secondary_head_column_points6_data = [
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19, y_offset - 19 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            hood_scheule_information[i]["FILTER_AREA"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 10, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19, y_offset - 19 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=False, dxfattribs={'layer': 'TABLE'})
        msp.add_lwpolyline(hood_table_secondary_head_column_points6_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_mtext(
        "(SQFT)",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 10, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_lwpolyline(hood_table_secondary_head_column_points6, close=False, dxfattribs={'layer': 'TABLE'})
    
    hood_table_secondary_head_column_points7 = [
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19, y_offset - 26),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24, y_offset - 26),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24, y_offset - 19),
    ]
    
    for i in range(number_of_hoods):
        hood_table_secondary_head_column_points7_data = [
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24, y_offset - 19 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            hood_scheule_information[i]["FILTER_VELOCITY"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 20 + 10, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24, y_offset - 19 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=False, dxfattribs={'layer': 'TABLE'})
        msp.add_lwpolyline(hood_table_secondary_head_column_points7_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_mtext(
        "(FPM)",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 20 + 10, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_lwpolyline(hood_table_secondary_head_column_points7, close=False, dxfattribs={'layer': 'TABLE'})
    
    hood_table_secondary_head_column_points8 = [
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24, y_offset - 26),
        
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10, y_offset - 26),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10, y_offset - 19),
        
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27, y_offset - 19),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27, y_offset - 26),
    ]
    
    for i in range(number_of_hoods):
        hood_table_secondary_head_column_points8_data = [
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24, y_offset - 26 - (i + 1) * 7),
        
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27, y_offset - 19 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27, y_offset - 26 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            hood_scheule_information[i]["LIGHT_QTY"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 10 + 19 + 24 + 10 + 5, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_scheule_information[i]["LIGHT_TYPE"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 12 + 19 + 24 + 10 + 5 + 15, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24, y_offset - 26 - (i + 1) * 7),

                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27, y_offset - 19 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=False, dxfattribs={'layer': 'TABLE'})
        msp.add_lwpolyline(hood_table_secondary_head_column_points8_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_mtext(
        "QTY",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 10 + 19 + 24 + 10 + 5, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "TYPE",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 12 + 19 + 24 + 10 + 5 + 15, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_lwpolyline(hood_table_secondary_head_column_points8, close=False, dxfattribs={'layer': 'TABLE'})
    
    hood_table_secondary_head_column_points9 = [
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27, y_offset - 26),
        
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22, y_offset - 26),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22, y_offset - 19),
        
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22, y_offset - 19),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22, y_offset - 26),
    ]
    
    for i in range(number_of_hoods):
        hood_table_secondary_head_column_points9_data = [
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27, y_offset - 26 - (i + 1) * 7),
        
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22, y_offset - 19 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22, y_offset - 26 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            f'{cabinet_information[i]["CABINETSIZE"] } X {cabinet_information[i]["CABINETHEIGHT"] } X {cabinet_information[i]["CABINETWIDTH"] }',
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 11, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            table_data["CABINETLOCATION"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 12, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27, y_offset - 26 - (i + 1) * 7),

                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22, y_offset - 19 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=False, dxfattribs={'layer': 'TABLE'})
        msp.add_lwpolyline(hood_table_secondary_head_column_points9_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_mtext(
        "SIZE",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 11, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "LOCATION",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 12, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_lwpolyline(hood_table_secondary_head_column_points9, close=False, dxfattribs={'layer': 'TABLE'})
    
    hood_table_secondary_head_column_points10 = [
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22, y_offset - 26),
        
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 22, y_offset - 26),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 22, y_offset - 19),
        
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 22 + 22, y_offset - 19),
        (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 22 + 22, y_offset - 26),
    ]
    
    for i in range(number_of_hoods):
        hood_table_secondary_head_column_points10_data = [
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22, y_offset - 26 - (i + 1) * 7),
        
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 22, y_offset - 26 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 22, y_offset - 19 - (i + 1) * 7),
            
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 22 + 22, y_offset - 19 - (i + 1) * 7),
            (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 22 + 22, y_offset - 26 - (i + 1) * 7),
        ]
        
        msp.add_mtext(
            hood_scheule_information[i]["SWITCH_HOOD"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 11, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        msp.add_mtext(
            hood_scheule_information[i]["SWITCH_LIGHT"],
            dxfattribs={
                'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 22 + 12, y_offset - 23 - (i + 1) * 7),
                'layer': 'TABLE',
                'char_height': 1.75 ,
                'attachment_point': 5
            }
        )
        
        if((i + 1) == number_of_hoods):
            last_line_points = [
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22, y_offset - 26 - (i + 1) * 7),

                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 22 + 22, y_offset - 26 - (i + 1) * 7),
                (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 22 + 22, y_offset - 19 - (i + 1) * 7),
            ]
            msp.add_lwpolyline(last_line_points, close=False, dxfattribs={'layer': 'TABLE'})
        msp.add_lwpolyline(hood_table_secondary_head_column_points10_data, close=False, dxfattribs={'layer': 'TABLE'})
    
    msp.add_mtext(
        "HOOD",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 11, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_mtext(
        "LIGHT",
        dxfattribs={
            'insert': (x_offset + 127 + 10 + 25 + 16 + 16 + 19 + 16 + 6 + 15 + 11 + 20 + 19 + 24 + 10 + 27 + 22 + 22 + 1 + 22 + 12, y_offset - 23),
            'layer': 'TABLE',
            'char_height': 1.75 ,
            'attachment_point': 5
        }
    )
    
    msp.add_lwpolyline(hood_table_secondary_head_column_points10, close=False, dxfattribs={'layer': 'TABLE'})
    
    
    

# Hood Schedule Table END
